Subject: bug#29608: python.el movement functions

From: Alex Branham <[email-masked]>
Date: Fri, 08 Dec 2017 15:37:15 -0600

On Fri 08 Dec 2017 at 17:56, Glenn Morris <[email-masked]> wrote:

> Alex Branham wrote:
>
>> Python movement statements do not always result in the behavior I'd
>> expect. Consider this python file (with (|) representing point):
>>
>> (|)for i in [1, 2, 3]:
>>     print(i)
>>
>> I'd expect M-x python-nav-forward-statement to result in
>>
>> for i in [1, 2, 3]:
>>     print(i)
>> (|)
>>
>> but instead you wind up with
>>
>> for i in [1, 2, 3]:
>>     (|)print(i)
>
> The actual result seems reasonable to me?

I'd argue that a "statement" should contain a whole logically valid statement, but I see your point.

>
>> and python-nav-forward-block (bound to M-e) is even worse. It results
>> in point not moving at all:
>>
>> (|)for i in [1, 2, 3]:
>>     print(i)
>
> It seems that you disagree with python.el's definition of "statement" and
> "block". Eg the block definition seems to be:
>
> (defconst python-rx-constituents
>   `((block-start          . ,(rx symbol-start
>                                  (or "def" "class" "if" "elif" "else" "try"
>                                      "except" "finally" "for" "while" "with"
>                                      ;; Python 3.5+ PEP492
>                                      (and "async" (+ space)
>                                           (or "def" "for" "with")))
>                                  symbol-end))

Shouldn't python-nav-forward-block actually navigate forward, though?
And if we're on the last block in the buffer, just leave point at the
end?

This might be off-topic, but what I'm trying to do is to write a function that I can bind so that C-<return> acts like it does in ESS where you can continue to hit it and it will eventually evaluate everything in the buffer. Here's what I have so far:

(defun python-shell-send-region-or-statement ()
  "Send the current region to the inferior python process if there is an active one, otherwise the current line."
  (interactive)
  (if (use-region-p)
      (python-shell-send-region (region-beginning) (region-end))
    (python-shell-send-statement)))

(defun python-shell-send-statement ()
  "Send the current line to the inferior python process for evaluation."
  (interactive)
  (save-excursion
    (let ((end (python-nav-end-of-statement))
          (beginning (python-nav-beginning-of-statement)))
      (python-shell-send-region beginning end))))

(defun python-shell-send-region-or-statement-and-step ()
  "Call `python-shell-send-region-or-statement' and then `python-nav-forward-statement'."
  (interactive)
  (python-shell-send-region-or-statement)
  (python-nav-forward-statement))